
Ruby - Bug #14495

Enumerator::Lazy#uniq invalid state

02/19/2018 12:57 PM - chopraanmol1 (Anmol Chopra)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.5.0preview1 (2017-10-10 trunk

60153) [x86_64-linux]

Backport: 2.3: UNKNOWN, 2.4: DONE, 2.5: DONE

Description

Currently

2.5.0-preview1 :001 > arr = (0..100).lazy.uniq{|i| i % 10}

 => #<Enumerator::Lazy: #<Enumerator::Lazy: 0..100>:uniq> 

2.5.0-preview1 :002 > arr.to_a

 => [0, 1, 2, 3, 4, 5, 6, 7, 8, 9] 

2.5.0-preview1 :003 > arr.to_a

 => [] 

 Expected

2.5.0-preview1 :001 > arr = (0..100).lazy.uniq{|i| i % 10}

 => #<Enumerator::Lazy: #<Enumerator::Lazy: 0..100>:uniq> 

2.5.0-preview1 :002 > arr.to_a

 => [0, 1, 2, 3, 4, 5, 6, 7, 8, 9] 

2.5.0-preview1 :003 > arr.to_a

 => [0, 1, 2, 3, 4, 5, 6, 7, 8, 9] 

 Solution Enumerator::Lazy#uniq's hash should be accessed from yielder memo

Associated revisions

Revision bb8532946030cb2e4337bd4f1f462e19ee507fa1 - 07/02/2018 08:30 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 62731,62735: [Backport #14495]

    Bug Fix Enumerator::Lazy#uniq state for multiple call

    * enumerator.c (lazy_uniq_i): create new hash for each calls.

      [Fix GH-1820]

    Currently

            2.5.0-preview1 :001 > arr = (0..100).lazy.uniq{|i| i % 10}

             => #<Enumerator::Lazy: #<Enumerator::Lazy: 0..100>:uniq>

            2.5.0-preview1 :002 > arr.to_a

             => [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]

            2.5.0-preview1 :003 > arr.to_a

             => []

    Expected

    arr.to_a to always return same output

    From: Anmol Chopra <anmolchopra@rocketbox.in>

    test_enumerator.rb: duplicate assertions

    * test/ruby/test_enumerator.rb (test_uniq): remove assertions

      which ared duplicate of lazy enumerator tests in

      test_lazy_enumerator.rb.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_5@63824 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision bb8532946030cb2e4337bd4f1f462e19ee507fa1 - 07/02/2018 08:30 AM - nagachika (Tomoyuki Chikanaga)
merge revision(s) 62731,62735: [Backport #14495]

    Bug Fix Enumerator::Lazy#uniq state for multiple call

    * enumerator.c (lazy_uniq_i): create new hash for each calls.

      [Fix GH-1820]

    Currently

            2.5.0-preview1 :001 > arr = (0..100).lazy.uniq{|i| i % 10}

             => #<Enumerator::Lazy: #<Enumerator::Lazy: 0..100>:uniq>

            2.5.0-preview1 :002 > arr.to_a

             => [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]

            2.5.0-preview1 :003 > arr.to_a

             => []

    Expected

    arr.to_a to always return same output

    From: Anmol Chopra <anmolchopra@rocketbox.in>

    test_enumerator.rb: duplicate assertions

    * test/ruby/test_enumerator.rb (test_uniq): remove assertions

      which ared duplicate of lazy enumerator tests in

      test_lazy_enumerator.rb.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_5@63824 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision bb853294 - 07/02/2018 08:30 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 62731,62735: [Backport #14495]

    Bug Fix Enumerator::Lazy#uniq state for multiple call

    * enumerator.c (lazy_uniq_i): create new hash for each calls.

      [Fix GH-1820]

    Currently

            2.5.0-preview1 :001 > arr = (0..100).lazy.uniq{|i| i % 10}

             => #<Enumerator::Lazy: #<Enumerator::Lazy: 0..100>:uniq>

            2.5.0-preview1 :002 > arr.to_a

             => [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]

            2.5.0-preview1 :003 > arr.to_a

             => []

    Expected

    arr.to_a to always return same output

    From: Anmol Chopra <anmolchopra@rocketbox.in>

    test_enumerator.rb: duplicate assertions

    * test/ruby/test_enumerator.rb (test_uniq): remove assertions

      which ared duplicate of lazy enumerator tests in

      test_lazy_enumerator.rb.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_5@63824 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 7d9572819bfd3932f206549576fbf931551947a6 - 08/27/2018 01:47 PM - U.Nakamura 

merge revision(s) 62731,62735: [Backport #14495]

    Bug Fix Enumerator::Lazy#uniq state for multiple call

    * enumerator.c (lazy_uniq_i): create new hash for each calls.

      [Fix GH-1820]

    Currently

            2.5.0-preview1 :001 > arr = (0..100).lazy.uniq{|i| i % 10}

             => #<Enumerator::Lazy: #<Enumerator::Lazy: 0..100>:uniq>
            2.5.0-preview1 :002 > arr.to_a

             => [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]

            2.5.0-preview1 :003 > arr.to_a

             => []

    Expected

    arr.to_a to always return same output

    From: Anmol Chopra <anmolchopra@rocketbox.in>

    test_enumerator.rb: duplicate assertions

    * test/ruby/test_enumerator.rb (test_uniq): remove assertions

      which ared duplicate of lazy enumerator tests in

      test_lazy_enumerator.rb.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_4@64558 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 7d9572819bfd3932f206549576fbf931551947a6 - 08/27/2018 01:47 PM - U.Nakamura 

merge revision(s) 62731,62735: [Backport #14495]

    Bug Fix Enumerator::Lazy#uniq state for multiple call

    * enumerator.c (lazy_uniq_i): create new hash for each calls.

      [Fix GH-1820]

    Currently

            2.5.0-preview1 :001 > arr = (0..100).lazy.uniq{|i| i % 10}

             => #<Enumerator::Lazy: #<Enumerator::Lazy: 0..100>:uniq>

            2.5.0-preview1 :002 > arr.to_a

             => [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]

            2.5.0-preview1 :003 > arr.to_a

             => []

    Expected

    arr.to_a to always return same output

    From: Anmol Chopra <anmolchopra@rocketbox.in>

    test_enumerator.rb: duplicate assertions

    * test/ruby/test_enumerator.rb (test_uniq): remove assertions

      which ared duplicate of lazy enumerator tests in

      test_lazy_enumerator.rb.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_4@64558 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 7d957281 - 08/27/2018 01:47 PM - U.Nakamura 

merge revision(s) 62731,62735: [Backport #14495]

    Bug Fix Enumerator::Lazy#uniq state for multiple call

    * enumerator.c (lazy_uniq_i): create new hash for each calls.

      [Fix GH-1820]

    Currently

            2.5.0-preview1 :001 > arr = (0..100).lazy.uniq{|i| i % 10}

             => #<Enumerator::Lazy: #<Enumerator::Lazy: 0..100>:uniq>

            2.5.0-preview1 :002 > arr.to_a

             => [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]

            2.5.0-preview1 :003 > arr.to_a

             => []

    Expected

    arr.to_a to always return same output

    From: Anmol Chopra <anmolchopra@rocketbox.in>
    test_enumerator.rb: duplicate assertions

    * test/ruby/test_enumerator.rb (test_uniq): remove assertions

      which ared duplicate of lazy enumerator tests in

      test_lazy_enumerator.rb.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_4@64558 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 02/19/2018 01:01 PM - chopraanmol1 (Anmol Chopra)

Solution https://github.com/ruby/ruby/pull/1820

#2 - 03/26/2018 07:41 PM - Eregon (Benoit Daloze)

Should this be backported?

#3 - 03/27/2018 05:56 PM - chopraanmol1 (Anmol Chopra)

Yes, to 2.4 and 2.5

#4 - 07/02/2018 08:12 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.3: UNKNOWN, 2.4: UNKNOWN, 2.5: UNKNOWN to 2.3: UNKNOWN, 2.4: REQUIRED, 2.5: REQUIRED

#5 - 07/02/2018 08:30 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.3: UNKNOWN, 2.4: REQUIRED, 2.5: REQUIRED to 2.3: UNKNOWN, 2.4: REQUIRED, 2.5: DONE

ruby_2_5 r63824 merged revision(s) 62731,62735.

#6 - 07/02/2018 08:30 AM - nagachika (Tomoyuki Chikanaga)

- Status changed from Open to Closed

Applied in changeset ruby_2_5|r63824.

merge revision(s) 62731,62735: [Backport #14495]

Bug Fix Enumerator::Lazy#uniq state for multiple call

* enumerator.c (lazy_uniq_i): create new hash for each calls.

  [Fix GH-1820]

Currently

 2.5.0-preview1 :001 > arr = (0..100).lazy.uniq{|i| i % 10}

  => #<Enumerator::Lazy: #<Enumerator::Lazy: 0..100>:uniq>

 2.5.0-preview1 :002 > arr.to_a

  => [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]

 2.5.0-preview1 :003 > arr.to_a

  => []

Expected

arr.to_a to always return same output

From: Anmol Chopra <anmolchopra@rocketbox.in>

test_enumerator.rb: duplicate assertions

* test/ruby/test_enumerator.rb (test_uniq): remove assertions

  which ared duplicate of lazy enumerator tests in

  test_lazy_enumerator.rb.

#7 - 08/27/2018 01:47 PM - usa (Usaku NAKAMURA)

- Backport changed from 2.3: UNKNOWN, 2.4: REQUIRED, 2.5: DONE to 2.3: UNKNOWN, 2.4: DONE, 2.5: DONE

ruby_2_4 r64558 merged revision(s) 62731,62735.
